Gaia/Gaia/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('django_admin/', admin.site.urls),

    path('account/', include('gaia_users.urls')),
    path('distrib/', include('gaia_distribs.urls')),
    path('paysans/', include('gaia_paysans.urls')),
    path('', include('gaia_public.urls')),
    path('admin/', include('gaia_admin.urls')),
]

admin.site.site_header = "Gaia - Administration"

# Use static() to add url mapping to serve static files during development (only)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

Gaia/gaia_distribs/forms.py
import enum
from collections import OrderedDict

from django import forms
from django.core.exceptions import ValidationError
from django.forms import MultiValueField, IntegerField, MultiWidget, NumberInput
from django.http import Http404
from django.urls import reverse

from datetime import datetime
from Gaia import settings
from gaia_utils.widgets import GaiaDateInput, GaiaTimeInput, GaiaDateTimeInput
from gaia_utils.models import GaiaSetting
from gaia_distribs.models import InscriptionAdherent


class TimeUnitChoices(enum.Enum):
    DAY = 1
    WEEK = 2
    MONTH = 3
    YEAR = 4


class FastDistributionCreationForm(forms.Form):
    date_from = forms.DateField(required=True, label="Date de départ",
                                widget=GaiaDateInput())
    date_to = forms.DateField(required=True, label="Date maximale (incluse)",
                              widget=GaiaDateInput())

    time_delta = forms.IntegerField(required=True, label="Intervalle entre deux distributions", min_value=1,
                                    widget=forms.NumberInput(attrs={"class": "form-control"}))
    delta_unit = forms.ChoiceField(required=True, label="Unité", choices=[
        (TimeUnitChoices.DAY.value, "Jour(s)"),
        (TimeUnitChoices.WEEK.value, "Semaine(s)"),
        (TimeUnitChoices.MONTH.value, "Mois"),
        (TimeUnitChoices.YEAR.value, "Année(s)")
    ], initial=TimeUnitChoices.WEEK.value, widget=forms.Select(attrs={"class": "form-control"}))

    heure_debut = forms.TimeField(required=True, label="Heure de début des distributions",
                                  widget=GaiaTimeInput())
    heure_fin = forms.TimeField(required=True, label="Heure de fin des distributions",
                                widget=GaiaTimeInput())
    lieu = forms.CharField(required=False, empty_value="", max_length=128, label="Lieu des distributions (optionnel)",
                           widget=forms.TextInput(attrs={"class": "form-control"}))

    date_visibilite_paysans = forms.DateTimeField(
        required=False,
        label="Date d'apparition pour les paysans (maintenant si vide)",
        widget=GaiaDateTimeInput()
    )
    date_visibilite_utilisateurs = forms.DateTimeField(
        required=False,
        label="Date d'apparition pour les utilisateurs (maintenant si vide)",
        widget=GaiaDateTimeInput()
    )

    def clean(self):
        cleaned_data = super().clean()
        date_from = cleaned_data.get("date_from")
        date_to = cleaned_data.get("date_to")

        if date_from > date_to:
            raise ValidationError(
                "La date de début doit être inférieure ou égale à celle de fin."
            )

class ProductsRegistrationsForm(forms.Form):

    signature_amap = forms.BooleanField(
        required=False,
        initial=True,
        label="Ajouter la signature de l'AMAP à toutes les inscriptions ?",
        widget=forms.CheckboxInput(attrs={"class": "form-check-input"})
    )

    signature_ferme = forms.BooleanField(
        required=False,
        initial=False,
        label="Ajouter la signature de la ferme à toutes les inscriptions ?",
        widget=forms.CheckboxInput(attrs={"class": "form-check-input"})
    )

    def __init__(self, distributions, produits, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self.distributions = distributions
        self.produits = produits
        self.produits_par_ferme = dict()

        for distrib in distributions:
            self.fields["distribution_" + str(distrib.id)] = forms.BooleanField(
                required=False,
                initial=False,
                label="{0}".format(
                    distrib.date_heure.strftime("%d/%m/%Y à %H:%M")
                ),
                widget=forms.CheckboxInput(attrs={"class": "form-check-input"})
            )
        
        for produit in produits:
            if produit.ferme not in list(self.produits_par_ferme.keys()):
                self.produits_par_ferme[produit.ferme] = []
            self.produits_par_ferme[produit.ferme].append(produit)
            self.fields["produit_" + str(produit.id)] = forms.BooleanField(
                required=False,
                initial=False,
                label=produit.nom,
                widget=forms.CheckboxInput(attrs={"class": "form-check-input"})
            )
            self.fields["produit_" + str(produit.id) + "_unites_dispo"] = forms.IntegerField(
                required=False,
                initial=0,
                min_value=0,
                label="Quantité disponible",
                widget=forms.NumberInput(attrs={"class": "form-control", "min":"0", "style":"width: 5em; direction: rtl"})
            )
            self.fields["produit_" + str(produit.id) + "_delai_max"] = forms.IntegerField(
                required=False,
                initial=0,
                min_value=0,
                label="Délai maximal de fermeture des commande (en jours)",
                widget=forms.NumberInput(attrs={"class": "form-control", "min":"0", "style":"width: 5em; direction: rtl"})
            )

class ProduitAmountWidget(NumberInput):
    template_name = "distribs/widgets/produit_amount_widget.html"

    def __init__(self, inscription_produit):
        super().__init__(attrs={
            "class": "form-control",
            "min": 0,
            "max": min(GaiaSetting.get_value("QUANTITE_PRODUIT_MAX_UTILISATEUR"), inscription_produit.unites_restantes)
        })
        self.inscription_produit = inscription_produit
        self.quantite_dispo = inscription_produit.unites_restantes
        self.tarif_vente = inscription_produit.tarif_vente

    def get_context(self, name, value, attrs):
        context = super().get_context(name, value, attrs)
        context['widget']['label'] = self.inscription_produit.produit.nom
        context['widget']['produit'] = {
            "quantite": self.inscription_produit.quantite_unitaire,
            "tarif_reference": self.inscription_produit.produit.tarif_reference,
            "tarif_vente": self.tarif_vente,
            "ferme": self.inscription_produit.produit.ferme.nom,
            "description": self.inscription_produit.produit.description,
            "commande_max": min(GaiaSetting.get_value("QUANTITE_PRODUIT_MAX_UTILISATEUR"), self.quantite_dispo)
        }
        return context


class DistributionProduitChoiceWidget(MultiWidget):

    def __init__(self, produits, *args, **kwargs):
        widgets = OrderedDict()
        for inscription in produits:
            widgets["produit_" + str(inscription.produit_id)] = ProduitAmountWidget(inscription_produit=inscription)

        super().__init__(widgets=widgets)

    def decompress(self, value):
        if value:
            values = dict()
            tuples = value.split(';')
            for entry in tuples:
                produit_id, produit_amount = entry.split("=")
                values["_produit_" + str(produit_id)] = produit_amount

            result = []
            for key in self.widgets_names:
                if key in values:
                    result.append(values[key])
                else:
                    result.append(None)

            return result
        return []

    def get_context(self, name, value, attrs):
        context = super().get_context(name, value, attrs)
        return context


class ProduitAmountField(IntegerField):

    def __init__(self, inscription_produit, **kwargs):
        super().__init__(
            min_value=0,
            max_value=GaiaSetting.get_value("QUANTITE_PRODUIT_MAX_UTILISATEUR"), 
            # Le cas où l'utilisateur veut commander plus que ce qui est disponible est géré lors de la soumission du formulaire
            label=inscription_produit.produit.nom,
            **kwargs
        )
        self.produit = inscription_produit.produit

    def clean(self, value):
        cleaned_value = super().clean(value)
        if cleaned_value is None:
            cleaned_value = 0
        return str(self.produit.id) + "=" + str(cleaned_value)


class DistributionProduitChoiceField(MultiValueField):

    def __init__(self, distribution, produits, *args, **kwargs):
        widget = DistributionProduitChoiceWidget(produits)

        fields = [
            ProduitAmountField(
                inscription,
                localize=False,
                required=False,
            )
            for inscription in produits
        ]

        super().__init__(fields=fields, widget=widget, require_all_fields=False, **kwargs)

        self.distribution = distribution
        self.nb_produits = len(fields)

        self.label = "Le {0} de {1} à {2}".format(
            self.distribution.date_heure.strftime("%d/%m/%Y"),
            self.distribution.date_heure.strftime("%H:%M"),
            self.distribution.date_heure_fin().strftime("%H:%M")
        )

        self.label_suffix = ""

    def compress(self, data_list):
        if data_list:
            res = ""
            for element in data_list:
                res += str(element) + ";"
            return res[:-1]
        return None


class RegisterAdherentDistribsForm(forms.Form):
    # dates_dispo = liste des dates possibles

    # produits choisis par date :
    # pour chaque date dispo, une liste de (id_produit, quantite)

    def __init__(self, distributions, produits_par_distrib, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self.distributions = distributions
        for distrib in distributions:
            self.fields[
                "distribution_" + str(distrib.id)
                ] = DistributionProduitChoiceField(distrib, produits_par_distrib[distrib.id], required=False)


class FinalisationInscriptionDistributionsForm(forms.Form):
    charte_amap = forms.BooleanField(required=True,
                                     initial=False)

    def __init__(self, contrats, *args, **kwargs):
        super().__init__(*args, **kwargs)

        self.contrats = contrats

Gaia/templates/distribs/inscription/confirmation_inscription.html
{% extends "users/userspace.html" %}

{% load template_utils %}

{% block content %}
    <div class="container py-4">
        <h1>S'inscrire à des distributions</h1>
        <h5>Inscription réussie !</h5>
        <br>
        <div class="alert alert-success">
            <i class="fas fa-check"></i> Super ! Tes contrats ont bien été enregistrés et signés ! <br> Les paniers sélectionnés seront produits. Tu t'es engagé à venir les chercher ! <br> Tu règleras ta commande à la prochaine distribution.
        </div>
        {{ PAGE_SUCCES_CONTRAT|safe }}
        <p> 
            Pour faire fonctionner notre AMAP, nous avons besoin que tu viennes aider à distribuer les légumes.
            Il s'agit de quelque chose de vital pour nous, car sans ça, il devient très vite difficile d'assurer les
            livraisons en raison du nombre de paniers demandés.<br>
            <br>
            Les informations pour t'inscrire sont sur 
            <a href="{% url 'profile_home' %}" target="_blank">"Ma Page"</a>.
            <br>
            <br>

            Et voilà, tu n'as plus qu'à venir récupérer tes paniers :)
        </p>
    </div>
{% endblock %}

Gaia/templates/distribs/inscription/finalisation_inscription.html
{% extends "users/userspace.html" %}

{% load template_utils %}

{% block content %}
    <div class="container py-4">
        <h1>S'inscrire à des distributions</h1>
        <h5>Signature des contrats</h5>

        <form action="#" method="post">
            {% csrf_token %}

            <div class="w-100 d-flex justify-content-between my-3">
                <a href="{% url 'recap_reglements_inscription' id_groupe=id_groupe %}" class="btn btn-secondary">
                    Retour
                </a>

                <button type="submit" class="btn btn-success">
                    Continuer
                </button>
            </div>

            <div class="alert alert-warning">
                <i class="fas fa-exclamation-triangle"></i> ATTENTION ! Ton contrat n'est pas encore validé, continue le processus jusqu'au bout en
                cliquant sur continuer.
            </div>

            {% if request.user.essai_gratuit and not request.user.adherent %}
            <div class="alert alert-danger">
                <i class="fas fa-exclamation-triangle"></i> ATTENTION: En passant cette commande, <b>tu vas consommer ta période d'essai sans adhésion</b>. Assure-toi d'avoir
                commandé tout ce que tu souhaites essayer, afin de ne pas te retrouver forcé.e d'adhérer.
            </div>
            {% endif %}

            {% if form.errors %}
                <div class="alert alert-danger my-3" role="alert">
                    {% for fieldname, errors in form.errors.items %}
                        {% if fieldname == "__all__" %}
                            Problèmes :
                        {% else %}
                            {{ fieldname }} :
                        {% endif %}
                        <ul>
                            {% for error in errors %}
                                <li>{{ error }}</li>
                            {% endfor %}
                        </ul>
                    {% endfor %}
                </div>
            {% endif %}

            <p>
                Une dernière étape avant de valider...
            </p>

            <div class="form-check">
                <input class="form-check-input" type="checkbox" id="id_charte_amap" name="charte_amap" required=""/>
                <label class="form-check-label" for="id_charte_amap">
                    Je confirme avoir pris connaissance de la
                    <a href="https://amap-aura.org/la-charte-des-amap/" target="_blank">
                        Charte des AMAP
                    </a>
                </label>
            </div>

            {% for contrat in contrats %}
                <div class="form-check">
                    <input class="form-check-input" type="checkbox" id="id_check_contrat_{{ contrat.id }}"
                           name="check_contrat_{{ contrat.id }}" required=""/>
                    <label class="form-check-label" for="id_check_contrat_{{ contrat.id }}">
                        J'accepte les termes du
                        <a href="{% url 'contrat_pdf' id_contrat=contrat.id %}" target="_blank">
                            contrat juridique avec {{ contrat.ferme.nom }}
                        </a>
                    </label>
                </div>
            {% endfor %}

            <div class="w-100 d-flex justify-content-end my-3">
                <button type="submit" class="btn btn-success">
                    Continuer
                </button>
            </div>
        </form>
    </div>
{% endblock %}

Gaia/templates/distribs/inscription/recap_reglement_inscription.html
{% extends "users/userspace.html" %}

{% load template_utils %}

{% block content %}
    <div class="container py-4">
        <h1>S'inscrire à des distributions</h1>
        <h5>Règlement des commandes</h5>

        <div class="w-100 d-flex justify-content-end  my-3">
            <a href="{% url 'finalisation_inscription' id_groupe=id_groupe %}" class="btn btn-success">
                Continuer
            </a>
        </div>

        <div class="alert alert-warning">
            <i class="fas fa-exclamation-triangle"></i> ATTENTION ! Ton contrat n'est pas encore validé, continue le processus jusqu'au bout en cliquant sur continuer.
        </div>

        {% if request.user.essai_gratuit and not request.user.adherent %}
        <div class="alert alert-danger">
            <i class="fas fa-exclamation-triangle"></i> ATTENTION: En passant cette commande, <b>tu vas consommer ta période d'essai sans adhésion</b>. Assure-toi d'avoir
            commandé tout ce que tu souhaites essayer, afin de ne pas te retrouver forcé.e d'adhérer.
        </div>
        {% endif %}

        {% if form.errors %}
            <div class="alert alert-danger" role="alert">
                {% for fieldname, errors in form.errors.items %}
                    {% if fieldname == "__all__" %}
                        Problèmes :
                    {% else %}
                        {{ fieldname }} :
                    {% endif %}
                    <ul>
                        {% for error in errors %}
                            <li>{{ error }}</li>
                        {% endfor %}
                    </ul>
                {% endfor %}
            </div>
        {% endif %}

        {% for contrat in contrats %}
            <article class="mb-5">
                <h3>{{ contrat.ferme.nom }}</h3>

                <p class="fw-bold">
                    Montant total de la commande : {{ contrat.valeur_totale|floatformat:2 }} €
                </p>

                <h5>Mode de règlement :</h5>

                {{ contrat.ferme.infos_paiement_html | safe }}
            </article>
        {% endfor %}

        <div class="w-100 d-flex justify-content-end  my-3">
            <a href="{% url 'finalisation_inscription' id_groupe=id_groupe %}" class="btn btn-success">
                Continuer
            </a>
        </div>
    </div>
{% endblock %}